From 37531b477eb9576c798ce96d8672fdc3b8bd82d5 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 03:48:12 +0000
Subject: [PATCH 791/2232] Combine demo into one root directory


---

diff --git a/Cargo.toml b/Cargo.toml
index 5458398..c950d2e 100644
--- a/Cargo.toml
+++ b/Cargo.toml
@@ -9,7 +9,7 @@ description = "Safe interop between Rust and C++"
 repository = "https://github.com/dtolnay/cxx"
 documentation = "https://docs.rs/cxx"
 readme = "README.md"
-exclude = ["/demo-cxx", "/gen", "/syntax", "/third-party"]
+exclude = ["/demo", "/gen", "/syntax", "/third-party"]
 keywords = ["ffi"]
 categories = ["development-tools::ffi", "api-bindings"]
 
@@ -34,7 +34,7 @@ rustversion = "1.0"
 trybuild = { version = "1.0.33", features = ["diff"] }
 
 [workspace]
-members = ["demo-rs", "flags", "gen/build", "gen/cmd", "gen/lib", "macro", "tests/ffi"]
+members = ["demo", "flags", "gen/build", "gen/cmd", "gen/lib", "macro", "tests/ffi"]
 
 [package.metadata.docs.rs]
 targets = ["x86_64-unknown-linux-gnu"]
diff --git a/demo/BUCK b/demo/BUCK
new file mode 100644
index 0000000..78e75e6
--- /dev/null
+++ b/demo/BUCK
@@ -0,0 +1,57 @@
+rust_binary(
+    name = "demo",
+    srcs = glob(["src/**/*.rs"]),
+    deps = [
+        ":demo-sys",
+        ":gen",
+        "//:cxx",
+    ],
+)
+
+cxx_library(
+    name = "gen",
+    srcs = [":gen-source"],
+    deps = [
+        ":demo-include",
+        ":include",
+    ],
+)
+
+genrule(
+    name = "gen-header",
+    srcs = ["src/main.rs"],
+    out = "generated.h",
+    cmd = "$(exe //:codegen) --header ${SRCS} > ${OUT}",
+    type = "cxxbridge",
+)
+
+genrule(
+    name = "gen-source",
+    srcs = ["src/main.rs"],
+    out = "generated.cc",
+    cmd = "$(exe //:codegen) ${SRCS} > ${OUT}",
+    type = "cxxbridge",
+)
+
+cxx_library(
+    name = "include",
+    exported_headers = {
+        "src/main.rs.h": ":gen-header",
+    },
+)
+
+cxx_library(
+    name = "demo-sys",
+    srcs = ["src/demo.cc"],
+    compiler_flags = ["-std=c++14"],
+    deps = [
+        ":demo-include",
+        ":include",
+    ],
+)
+
+cxx_library(
+    name = "demo-include",
+    exported_headers = ["include/demo.h"],
+    deps = ["//:core"],
+)
diff --git a/demo/BUILD b/demo/BUILD
new file mode 100644
index 0000000..1edc65c
--- /dev/null
+++ b/demo/BUILD
@@ -0,0 +1,58 @@
+load("//tools/bazel:rust.bzl", "rust_binary", "rust_library")
+
+rust_binary(
+    name = "demo",
+    srcs = glob(["src/**/*.rs"]),
+    deps = [
+        ":demo-sys",
+        ":gen",
+        "//:cxx",
+    ],
+)
+
+cc_library(
+    name = "gen",
+    srcs = [":gen-source"],
+    deps = [
+        ":demo-include",
+        ":include",
+    ],
+)
+
+genrule(
+    name = "gen-header",
+    srcs = ["src/main.rs"],
+    outs = ["main.rs.h"],
+    cmd = "$(location //:codegen) --header $< > $@",
+    tools = ["//:codegen"],
+)
+
+genrule(
+    name = "gen-source",
+    srcs = ["src/main.rs"],
+    outs = ["generated.cc"],
+    cmd = "$(location //:codegen) $< > $@",
+    tools = ["//:codegen"],
+)
+
+cc_library(
+    name = "include",
+    hdrs = [":gen-header"],
+    include_prefix = "demo/src",
+)
+
+cc_library(
+    name = "demo-sys",
+    srcs = ["src/demo.cc"],
+    copts = ["-std=c++14"],
+    deps = [
+        ":demo-include",
+        ":include",
+    ],
+)
+
+cc_library(
+    name = "demo-include",
+    hdrs = ["include/demo.h"],
+    deps = ["//:core"],
+)
diff --git a/demo/Cargo.toml b/demo/Cargo.toml
new file mode 100644
index 0000000..d2147ab
--- /dev/null
+++ b/demo/Cargo.toml
@@ -0,0 +1,12 @@
+[package]
+name = "cxxbridge-demo"
+version = "0.0.0"
+authors = ["David Tolnay <dtolnay@gmail.com>"]
+edition = "2018"
+publish = false
+
+[dependencies]
+cxx = { path = ".." }
+
+[build-dependencies]
+cxx-build = { path = "../gen/build" }
diff --git a/demo/build.rs b/demo/build.rs
new file mode 100644
index 0000000..a3c31b3
--- /dev/null
+++ b/demo/build.rs
@@ -0,0 +1,10 @@
+fn main() {
+    cxx_build::bridge("src/main.rs")
+        .file("src/demo.cc")
+        .flag_if_supported("-std=c++14")
+        .compile("cxxbridge-demo");
+
+    println!("cargo:rerun-if-changed=src/main.rs");
+    println!("cargo:rerun-if-changed=src/demo.cc");
+    println!("cargo:rerun-if-changed=include/demo.h");
+}
diff --git a/demo/include/demo.h b/demo/include/demo.h
new file mode 100644
index 0000000..fafc474
--- /dev/null
+++ b/demo/include/demo.h
@@ -0,0 +1,24 @@
+#pragma once
+#include "rust/cxx.h"
+#include <memory>
+#include <string>
+
+namespace org {
+namespace example {
+
+class ThingC {
+public:
+  ThingC(std::string appname);
+  ~ThingC();
+
+  std::string appname;
+};
+
+struct SharedThing;
+
+std::unique_ptr<ThingC> make_demo(rust::Str appname);
+const std::string &get_name(const ThingC &thing);
+void do_thing(SharedThing state);
+
+} // namespace example
+} // namespace org
diff --git a/demo/src/demo.cc b/demo/src/demo.cc
new file mode 100644
index 0000000..79c693f
--- /dev/null
+++ b/demo/src/demo.cc
@@ -0,0 +1,21 @@
+#include "demo/include/demo.h"
+#include "demo/src/main.rs.h"
+#include <iostream>
+
+namespace org {
+namespace example {
+
+ThingC::ThingC(std::string appname) : appname(std::move(appname)) {}
+
+ThingC::~ThingC() { std::cout << "done with ThingC" << std::endl; }
+
+std::unique_ptr<ThingC> make_demo(rust::Str appname) {
+  return std::make_unique<ThingC>(std::string(appname));
+}
+
+const std::string &get_name(const ThingC &thing) { return thing.appname; }
+
+void do_thing(SharedThing state) { print_r(*state.y); }
+
+} // namespace example
+} // namespace org
diff --git a/demo/src/main.rs b/demo/src/main.rs
new file mode 100644
index 0000000..ee7e093
--- /dev/null
+++ b/demo/src/main.rs
@@ -0,0 +1,39 @@
+#[cxx::bridge(namespace = org::example)]
+mod ffi {
+    struct SharedThing {
+        z: i32,
+        y: Box<ThingR>,
+        x: UniquePtr<ThingC>,
+    }
+
+    extern "C" {
+        include!("demo/include/demo.h");
+
+        type ThingC;
+        fn make_demo(appname: &str) -> UniquePtr<ThingC>;
+        fn get_name(thing: &ThingC) -> &CxxString;
+        fn do_thing(state: SharedThing);
+    }
+
+    extern "Rust" {
+        type ThingR;
+        fn print_r(r: &ThingR);
+    }
+}
+
+pub struct ThingR(usize);
+
+fn print_r(r: &ThingR) {
+    println!("called back with r={}", r.0);
+}
+
+fn main() {
+    let x = ffi::make_demo("demo of cxx::bridge");
+    println!("this is a {}", ffi::get_name(x.as_ref().unwrap()));
+
+    ffi::do_thing(ffi::SharedThing {
+        z: 222,
+        y: Box::new(ThingR(333)),
+        x,
+    });
+}

